## NOTE nonfree only
# Not for linux 32bits
ExclusiveArch: armv7hl aarch64 x86_64
%define _disable_ld_no_undefined 1
%global ocpnlibscommit0 a001083af21de2e3faa970b245877a5ee5899aba
%define piname	o-charts_pi

Name:		opencpn-o-charts-plugin
Summary:	Provides support for encrypted charts available from o-charts.org
Version:	2.0.30.0
Release:	%mkrel 2
License:	GPLv3+ & partly closed Source
# See README.md for distribution permission for pre-built binary
Group:		Geography
URL:		https://github.com/bdbcat/o-charts_pi
Source0:	https://github.com/bdbcat/%{piname}/archive/%{piname}-%{version}.tar.gz
Source1:    https://github.com/OpenCPN/opencpn-libs/archive/%{ocpnlibscommit0}/opencpn-libs-%{ocpnlibscommit0}.tar.gz
Patch0:     o-charts_pi-2.0.30.0-GetArch.patch
Patch1:     o-charts-oeserverd-CMakeLists.patch
Patch2:     opencpn-libs-a001083-tinyxml.patch
Patch3:     opencpn-libs-a001083-json.patch
Patch4:     opencpn-libs-a001083-ocpn_plugin.patch

BuildRequires:	git
BuildRequires:	cmake
BuildRequires:	gettext
BuildRequires:	wxgtku3.2-devel
BuildRequires:	pkgconfig(bzip2)
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(glew)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(tinyxml)
BuildRequires:	pkgconfig(webkit2gtk-4.1)
BuildRequires:  pkgconfig(jsoncpp)

Requires:	opencpn
Provides:	%{piname} = %{version}
Obsoletes:	opencpn-oernc-plugin < 1.2.5-4
Obsoletes:	opencpn-oesenc-plugin < 4.2.17-2

%description
This is a plugin for OpenCPN [1] providing support for encrypted charts
available from o-charts.org [2]. The plugin supports purchase, downloading
and rendering of these charts.

-[1] https://www.opencpn.org
-[2] http://o-charts.org

This package is in the nonfree repository as it contains a proprietary binary.
See README.md in the package doc directory for the license information.

%prep
%setup -a1 -n %{piname}-%{version}

%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1
%patch -P 3 -p1
%patch -P 4 -p1

mv opencpn-libs-%{ocpnlibscommit0}/{.,}* opencpn-libs/

%build
%ifarch armv7hl aarch64 x86_64
%cmake 
%cmake_build
%endif


%install

%ifarch armv7hl aarch64 x86_64
mkdir -p %{buildroot}%{_libdir}/opencpn
mkdir -p %{buildroot}%{_docdir}/%{piname}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_datadir}/opencpn/plugins/%{piname}/data
mkdir -p %{buildroot}%{_datadir}/locale

install -Dpm755 %{_vpath_builddir}/lib%{piname}.so %{buildroot}%{_libdir}/opencpn
cp -r data/ %{buildroot}%{_datadir}/opencpn/plugins/%{piname}
cp -r %{_vpath_builddir}/app/o-charts-2.0-mageia-*/share/locale %{buildroot}%{_datadir}
%endif

%ifarch x86_64
mkdir -p %{buildroot}/usr/lib
cp ./libs/oeserverd/linux64/oexserverd %{buildroot}%{_bindir}
cp ./libs/oeserverd/linux64/libsgl*.so %{buildroot}%{_bindir}
cp ./libs/oeserverd/linux64/libsgl*.so %{buildroot}%{_libdir}
cp ./libs/oeserverd/linux64/libsgl*.so %{buildroot}/usr/lib/
cp ./libs/oeserverd/linux64/libsgl*.so %{buildroot}%{_libdir}/opencpn
%endif

%ifarch armv7hl
cp ./libs/oeserverd/linuxarm/oexserverd %{buildroot}%{_bindir}
cp ./libs/oeserverd/linuxarm/libsgl*.so %{buildroot}%{_bindir}
cp ./libs/oeserverd/linuxarm/libsgl*.so %{buildroot}%{_libdir}
cp ./libs/oeserverd/linuxarm/libsgl*.so %{buildroot}%{_libdir}/opencpn
%endif

%ifarch aarch64
mkdir -p %{buildroot}/usr/lib
cp ./libs/oeserverd/linuxarm64/oexserverd %{buildroot}%{_bindir}
cp ./libs/oeserverd/linuxarm64/libsgl*.so %{buildroot}%{_bindir}
cp ./libs/oeserverd/linuxarm64/libsgl*.so %{buildroot}%{_libdir}
cp ./libs/oeserverd/linuxarm64/libsgl*.so %{buildroot}/usr/lib/
cp ./libs/oeserverd/linuxarm64/libsgl*.so %{buildroot}%{_libdir}/opencpn
%endif

%files
%{_libdir}/opencpn/
%{_bindir}/oexserverd
%ifarch aarch64 x86_64
/usr/lib/libsgl*.so
%endif
%{_bindir}/libsgl*.so
%{_libdir}/libsgl*.so
%{_datadir}/opencpn/plugins/%{piname}/data/*.*
%{_datadir}/locale


%changelog
* Mon Apr 28 2025 philippedidier <philippedidier> 2.0.30.0-2.mga10
+ Revision: 2179612
- little patch added for GCC 15.1.0

* Sun Mar 30 2025 philippedidier <philippedidier> 2.0.30.0-1.mga10.nonfree
+ Revision: 2171621
- version 2.0.30.0 new nonfree binary for aarch64

* Wed Nov 27 2024 philippedidier <philippedidier> 2.0.25.0-1.mga10.nonfree
+ Revision: 2119482
- new version 2.0.25.0 improving charts display

* Sat Sep 07 2024 philippedidier <philippedidier> 2.0.10.0-1.mga10.nonfree
+ Revision: 2093572
- new version 2.0.10.0

* Mon Jun 24 2024 philippedidier <philippedidier> 2.0.6.0-1.mga10.nonfree
+ Revision: 2076402
- new version 2.0.6.0

* Fri Jan 05 2024 philippedidier <philippedidier> 2.0.1.9-2.mga10.nonfree
+ Revision: 2027868
- new patch for aarch64
- new version rebuilt upon wekkit2gtk-4.1

* Tue May 30 2023 philippedidier <philippedidier> 2.0.0.49-1.mga9.nonfree
+ Revision: 1959943
- new version 2.0.0.49 built upon wxgtku 3.2

* Tue Mar 14 2023 philippedidier <philippedidier> 1.0.29.0-4.mga9.nonfree
+ Revision: 1949014
- correct the version of the plugins to obsolete

* Sat Oct 08 2022 papoteur <papoteur> 1.0.29.0-3.mga9.nonfree
+ Revision: 1895569
- Rebuild for webkit2gtk-4.1

* Mon Jul 11 2022 philippedidier <philippedidier> 1.0.29.0-2.mga9.nonfree
+ Revision: 1868394
- new version 1.0.29.0 correct patch for aarch64
- new version 1.0.29.0 patch added for aarch64
- now try to build on aarch64
- new try to really do not build on linux 32bits
- really do not build on linux 32bits
- really do not build on linux 32bits
- do not build on linux 32bits
- do not build on linux 32bits
- imported package opencpn-o-charts-plugin

